<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         edit_splashpage.php
Description:  Administrative module to splashpage

*/

    include "../modules/mod_config.php";
    include "../modules/mod_admin.php";
    include "../modules/class_translation.php";
    include "../modules/class_user.php";
    include "../modules/class_textfile.php";

    $bErrorOccured = false;
    $errorString = "";
    $cFile = new cTextFile;

    // Check privilege
    check_login();
    if (user_is_customer() == true)
    {
        log_out();
        return;
    }
    if (user_is_reporter() == true)
    {
        header('location: '. $ADMIN_CONFIG_SITE);
        return;
    }

    // Cancel titles?
    if (isset($_POST['splashpage_Cancel']))
    {
        header('location: ' . $ADMIN_CONFIG_SITE);
        return;
    }
    
    // Save splashpage?
    if (isset($_POST['splashpage_Save']))
    {
        // Activate
        $conConfig->SetParameter("show_splashpage", isset($_POST['splashpage_Activate']) == true);
        // Splashpage title
        $cFile->SaveToFile($SPLASHPAGETITLE_CONFIG_FILE, $_POST['splashpage_Title']);
        // Splashpage image
        if (isset($_POST['splashpage_NoImage']) == true)
        {
            if (file_exists($conConfig->GetParameter("image_splashpage")) == true)
                unlink($conConfig->GetParameter("image_splashpage"));
        }
        if (!(empty ($_FILES['splashpage_Image']['name'])))
        {
            if (check_image_extension($_FILES['splashpage_Image']['name']) == false)  // Check extension
            {
                $errorString = $cTrans->GetTranslation('admin_artedt_errorimagetype') . '!';
            }
            else
            {
                // Delete old one first!
                if (file_exists($conConfig->GetParameter("image_splashpage")) == true)
                    unlink($conConfig->GetParameter("image_splashpage"));
                $destName = $SPLASHPAGE_IMAGE . retrieve_extension($_FILES['splashpage_Image']['name']);
                // Is resize necessary? ...otherwise copy
                if(resize_image($_FILES['splashpage_Image']['name'], $_FILES['splashpage_Image']['tmp_name'], $destName, 0, 0, true) == false)
                {
                    $errorString = $cTrans->GetTranslation("admin_splashed_errorimagesave") . ' ' . $_FILES['splashpage_Image']['tmp_name'] . '!';
                }
                else
                {
                    $conConfig->SetParameter("image_splashpage", $destName);
                }
            }
        }
        if ($conConfig->SaveConfigFile() == false)
            $errorString = $cTrans->GetTranslation("admin_splashed_errorconfigsave");
        if ($errorString == "")
        {
            log_message ('User ' . get_user_name() . ' saved splashpage');
            header('location: ' . $ADMIN_CONFIG_SITE);
            return;
        }
    }

    // Display
    print_admin_header($cTrans->GetTranslation('admin_splashed_head'), true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'), "", "", false);
    // Enable editor?
    if ($ADMIN_USEWYSIGWYG == true)
        print_wysiwyg_header();
    finish_admin_header($cTrans->GetTranslation('admin_splashed_head'), true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'), "", "");
    print_help_link($ADMIN_HELP_FILE . '#n2-1-2', $cTrans->GetTranslation('admin_help'));
    if ($errorString != "")
        print_error_message ($errorString);
        
    echo_r('<form action="' . $_SERVER['PHP_SELF'] . '" method="post" enctype="multipart/form-data">');
    // Activate splash page
    echo_r ('<hr>');
    echo_r ('<table border="0" width="100%">');
    echo_r ('  <tr>');
    echo_r ('    <td width="30%">' . $cTrans->GetTranslation('admin_splashed_usesplashpage') . ':</td>');
    echo_r ('    <td>');
    echo   ('      <input type="checkbox" name="splashpage_Activate" value="1"');
    if ($conConfig->GetParameter("show_splashpage") == "1")
        echo (' checked');
    echo_r ('>');
    echo_r ('    </td>');
    echo_r ('  </tr>');
    echo_r ('</table>');
    // Splash page image
    echo_r ('<hr>');
    echo_r ('<table border="0" width="100%">');
    echo_r ('  <tr>');
    echo_r('    <td width="30%">' . $cTrans->GetTranslation('admin_splashed_splashpageimage') . ':</td>');
    echo_r ('    <td>');
    if (file_exists($conConfig->GetParameter("image_splashpage")) == true)
    {
        echo_r('     <br><img src="' . $conConfig->GetParameter("image_splashpage") . '" alt="">');
    }
    echo_r('    <br><input type="file" name="splashpage_Image" size="50">');
    echo_r('    <br><input type="checkbox" name="splashpage_NoImage" value="1">&nbsp;' . $cTrans->GetTranslation('admin_splashed_noimage') . '</td>');
    echo_r('    </td>');
    echo_r ('  </tr>');
    echo_r ('</table>');
    // Splash page text
    echo_r ('<hr>');
    echo_r ('<table border="0" width="100%">');
    echo_r ('  <tr>');
    echo_r ('    <td width="30%">' . $cTrans->GetTranslation('admin_splashed_splashpagetext') . '</td>');
    echo_r ('    <td>');
    echo_r ('      <textarea cols="80" rows="14" name="splashpage_Title" wrap="off">' . $cFile->LoadFromFile($SPLASHPAGETITLE_CONFIG_FILE) . '</textarea>');
    echo_r ('    </td>');
    echo_r ('  </tr>');
    echo_r ('</table>');

    print_bottom_links("splashpage_Save", $cTrans->GetTranslation('admin_save'),
                       "splashpage_Cancel", $cTrans->GetTranslation('admin_cancel'), false);
    echo_r ('</form>');

    print_admin_footer();
?>