<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         edit_user.php
Description:  Administrative module to edit users/customers or create new ones

*/

    include "../modules/class_user.php";
    include "../modules/class_userlist.php";
    include "../modules/mod_config.php";
    include "../modules/mod_admin.php";
    include "../modules/class_translation.php";

    $b_NotFinished = true;
    $b_ErrorOccured = false;
    $usrId = "";
    $errorString = "";

    // Check privileges
    check_login();
    if (user_is_customer() == true)
    {
        log_out();
        return;
    }

    // Check action
    $usrEdtAction = "new";
    if (isset ($_POST['usr_EdtAction']) == true)
    {
        if ($_POST['usr_EdtAction'] == "edit")
            $usrEdtAction = "edit";
    }
    else if (isset ($_GET['action']) == true)
    {
        if ($_GET['action'] == "edit")
            $usrEdtAction = "edit";
    }

    // User/customer mode?
    $usrMode="user";
    if (isset($_GET['mode']) && $_GET['mode'] != "")
        $usrMode = $_GET['mode'];
    else if (isset($_POST['usr_mode']) && $_POST['usr_mode'] != "")
        $usrMode = $_POST['usr_mode'];
    $usrUser = new cUser;
    if ($usrMode == "user")
        $usrUser->SetFolder($USER_FOLDER);
    else
        $usrUser->SetFolder($CUSTOMER_FOLDER);

    // Check privileges again
    if ($usrEdtAction == "edit")  // Edit
    {
        if (user_is_reporter() == true && $usrMode == "user")
        {
            header('location: ' . $ADMIN_USRLIST_SITE . '?mode=' . $usrMode);
            return;
        }
    }
    else  // New
    {
        if ($usrMode == "user" && user_is_admin() == false)
        {
            header('location: ' . $ADMIN_USRLIST_SITE . '?mode=' . $usrMode);
            return;
        }
    }

    if ($usrEdtAction == "edit")  // Edit -> load it
    {
        if (isset ($_POST['usr_id']) == true)
            $usrId = $_POST['usr_id'];
        else if (isset ($_GET['id']) == true)
            $usrId = $_GET['id'];
        if ($usrUser->LoadUserFromId($usrId) == false)
        {
            print_error_message($cTrans->GetTranslation('admin_usredt_errorload') . ' ' . $usrId);
            return;
        }
    }

    // User edit cancelled?
    if (isset ($_POST['usr_Cancel']))
    {
        header('location: ' . $ADMIN_USRLIST_SITE . '?mode=' . $usrMode);
        return;
    }

    // Check for errors and if none, store the user values
    if (isset ($_POST['usr_Save']))
    {

        // Customers don't need an alias
        if ($_POST['usr_type'] != $USERTYPE_CUSTOMER || $_POST['usr_alias'] != "")
        {
            $usrl_UserList = new cUserList;
            $usrl_UserList->SetFolder($USER_FOLDER);
            $usrId = "";
            if (isset($_POST['usr_id']))
                $usrId = $_POST['usr_id'];
            if ($_POST['usr_alias'] == "")
            {
                $errorString = $cTrans->GetTranslation('admin_usr_erroralias') . '!';
                $b_ErrorOccured = true;
            }
            else if ($usrl_UserList->CheckAlias($_POST['usr_alias'], $usrId) == false)
            {
                $errorString = $cTrans->GetTranslation('admin_usr_erroraliasexits') . '!';
                $b_ErrorOccured = true;
            }
        }
        // Customers don't need a password
        if ($_POST['usr_type'] != $USERTYPE_CUSTOMER || $_POST['usr_password'] != "")
        {
            if ($_POST['usr_password'] == "" || $_POST['usr_passwordconf'] == "")
            {
                $errorString = $cTrans->GetTranslation('admin_usr_errorpassword') . '!';
                $b_ErrorOccured = true;
            }
            if ($_POST['usr_password'] != $_POST['usr_passwordconf'])
            {
                $errorString = $cTrans->GetTranslation('admin_usr_errorpassconf') . '!';
                $b_ErrorOccured = true;
            }
        }
        // Customer MUST have an address
        if ($_POST['usr_type'] == $USERTYPE_CUSTOMER)
        {
            if (!ereg("^.+@.+\\..+$", $_POST['usr_email']))
            {
                $errorString = $cTrans->GetTranslation('admin_usr_erroremail') . '!';
                $b_ErrorOccured = true;
            }
            else
            {
                $missingElement = "";
                if ($_POST['usr_firstname'] == "")
                    $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('admin_usr_firstname');
                if ($_POST['usr_lastname'] == "")
                    $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('admin_usr_lastname');
                if ($_POST['usr_street'] == "")
                    $missingElement = $missingElement . '<br> -> ' . $cTrans->GetTranslation('admin_usr_street');
                if ($_POST['usr_streetno'] == "")
                    $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('admin_usr_streetno');
                if ($_POST['usr_city'] == "")
                    $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('admin_usr_city');
                if ($_POST['usr_zipcode'] == "")
                    $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('admin_usr_zipcode');
                if ($_POST['usr_land'] == "")
                    $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('admin_usr_land');
                if ($_POST['usr_phoneno'] == "")
                    $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('admin_usr_phoneno');
                if ($_POST['usr_email'] == "")
                    $missingElement = $missingElement . '<br> -> '. $cTrans->GetTranslation('admin_usr_email');

                if ($missingElement != "")
                {
                    $errorString = $cTrans->GetTranslation('admin_usr_erroraddress') . ': ' . $missingElement;
                    $b_ErrorOccured = true;
                }
            }
        }

        if ($b_ErrorOccured == false)
        {
            // If done, fill the rest of the parameters
            if ($usrEdtAction == "new")    // New -> create Id first
            {
                $usrUser->CreateUser();
                if ($usrMode == "user")
                    $usrUser->SetFolder($USER_FOLDER);
                else
                    $usrUser->SetFolder($CUSTOMER_FOLDER);
            }
            $usrUser->SetAlias($_POST['usr_alias']);
            if ($_POST['usr_password'] != $usrUser->GetPassword())  // Only if changed, cause of MD5
                $usrUser->SetPassword($_POST['usr_password']);
            $usrUser->SetType($_POST['usr_type']);
            $usrUser->SetFirstName($_POST['usr_firstname']);
            $usrUser->SetLastName($_POST['usr_lastname']);
            $usrUser->SetStreet($_POST['usr_street']);
            $usrUser->SetStreetNo($_POST['usr_streetno']);
            $usrUser->SetCity($_POST['usr_city']);
            $usrUser->SetZipCode($_POST['usr_zipcode']);
            $usrUser->SetLand($_POST['usr_land']);
            $usrUser->SetTelephoneNo($_POST['usr_phoneno']);
            $usrUser->SetEmail($_POST['usr_email']);
            if (isset($_POST['usr_newsletter']))
                $usrUser->SetWantsNewsletter($_POST['usr_newsletter'] == "1");
            else
                $usrUser->SetWantsNewsletter(false);
            if ($usrUser->SaveUser() == false)
            {
                if ($usrEdtAction == "new")
                    $errorString = $cTrans->GetTranslation('admin_usredt_errorcreate') . '!';
                else
                    $errorString = $cTrans->GetTranslation('admin_usredt_errorsave') . '!';
                $b_ErrorOccured = true;
            }
            else
            {
                if ($usrEdtAction == "edit")
                {
                    // User is saved.
                    log_message ('User ' . get_user_name() . ' saved user ' . $usrUser->GetId());
                    header ('Location: ' . $ADMIN_USRLIST_SITE . '?mode=' . $usrMode);
                    return;
                }
                else
                    log_message ('User ' . get_user_name() . ' created user ' . $usrUser->GetId());
                $b_NotFinished = false;
            }
        }
    }

    // Display the input dialog for edit user
    if ($usrMode == "user")
        $titleString = $cTrans->GetTranslation('admin_usredt_newhead');
    else
        $titleString = $cTrans->GetTranslation('admin_usredt_newheadcust');
    if ($usrEdtAction == "edit")  // Edit
    {
        if ($usrMode == "user")
            $titleString = $cTrans->GetTranslation('admin_usredt_edithead');
        else
            $titleString = $cTrans->GetTranslation('admin_usredt_editheadcust');
    }
    if ($usrMode == "user")
    {
        print_admin_header($titleString, true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'),
                           $ADMIN_USRLIST_SITE . '?mode=' . $usrMode, $cTrans->GetTranslation('admin_usrl_button'));
        print_help_link($ADMIN_HELP_FILE . '#n1-6', $cTrans->GetTranslation('admin_help'));
    }
    else
    {
        print_admin_header($titleString, true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'),
                           $ADMIN_USRLIST_SITE . '?mode=' . $usrMode, $cTrans->GetTranslation('admin_usrl_buttoncustomer'));
        print_help_link($ADMIN_HELP_FILE . '#1-4', $cTrans->GetTranslation('admin_help'));
    }
    if ($errorString !="")
        print_error_message($errorString);

    if ($b_NotFinished == false)
    {
        // User is created. Display form to create another or go back to user list
        echo_r('<p>' . $cTrans->GetTranslation('admin_usredt_usercreated') . ' : ' . $usrUser->GetId() . '<br></p>');
        echo_r('<form action="' . $_SERVER['PHP_SELF'] . '" method="post" enctype="multipart/form-data">');
        print_bottom_links("usr_New", $cTrans->GetTranslation('admin_usredt_createanother'),
                           "usr_Cancel", $cTrans->GetTranslation('admin_ok'), false);
        echo_r('<input type="hidden" name="usr_mode" value="' . $usrMode . '">');
        echo_r('</form>');
        return;
    }

    echo_r('<form action="' . $_SERVER['PHP_SELF'] . '" method="post" enctype="multipart/form-data">');
    if ($b_NotFinished == true)
    {
        echo_r('<table width="100%">');
        if ($usrEdtAction == "edit")  // Edit
        {
            echo_r('  <tr>');
            echo_r('    <td>' . $cTrans->GetTranslation('admin_usr_id') . ':</td>');
            echo_r('    <td><b>' . $usrUser->GetId() . '</b>');
            echo_r('      <input type="hidden" value="' .  $usrUser->GetId() . '" name="usr_id">  ');
            echo_r('    </td>');
            echo_r('  </tr>');
        }
        echo_r('  <tr>');
        echo_r('    <td width="30%">' . $cTrans->GetTranslation('admin_usr_alias') . ':</td>');
        if (isset($_POST['usr_alias']))
            echo_r('    <td><input type="text" name="usr_alias" size="30" value="' . $_POST['usr_alias'] . '"></td>');
        else
            echo_r('    <td><input type="text" name="usr_alias" size="30" value="' .  $usrUser->GetAlias() . '"></td>');
        echo_r('  </tr>');
        echo_r('  <tr>');
        echo_r('    <td>' . $cTrans->GetTranslation('admin_usr_password') . ':</td>');
        if (isset($_POST['usr_password']))
            echo_r('    <td><input type="password" name="usr_password" size="30" value="' . $_POST['usr_password'] . '"></td>');
        else
            echo_r('    <td><input type="password" name="usr_password" size="30" value="' . $usrUser->GetPassword() . '"></td>');
        echo_r('  </tr>');
        echo_r('  <tr>');
        echo_r('    <td>' . $cTrans->GetTranslation('admin_usr_passwordconf') . ':</td>');
        if (isset($_POST['usr_passwordconf']))
            echo_r('    <td><input type="password" name="usr_passwordconf" size="30" value="' . $_POST['usr_passwordconf'] . '"></td>');
        else
            echo_r('    <td><input type="password" name="usr_passwordconf" size="30" value="' . $usrUser->GetPassword() . '"></td>');
        echo_r('  </tr>');
        echo_r('  <tr>');
        echo_r('    <td>' . $cTrans->GetTranslation('admin_usr_type') . ':</td>');
        $usrType = $usrUser->GetType();
        if (isset($_POST['usr_type']))
            $usrType = $_POST['usr_type'];
        if (user_is_admin() == true && $usrMode == "user")
        {
            echo_r('    <td><select name="usr_type">');
//            echo('        <option value="' . $USERTYPE_CUSTOMER . '"');
//            if ($usrType == $USERTYPE_CUSTOMER)
//                echo(' selected');
//            echo_r ('>'. $cTrans->GetTranslation('admin_usr_typecustomer') . '</option>');
            echo('        <option value="' . $USERTYPE_REPORTER . '"');
            if ($usrType == $USERTYPE_REPORTER)
                echo(' selected');
            echo_r ('>'. $cTrans->GetTranslation('admin_usr_typereporter') .'</option>');
            echo('        <option value="' . $USERTYPE_SITEOWNER . '"');
            if ($usrType == $USERTYPE_SITEOWNER)
                echo(' selected');
            echo_r ('>'. $cTrans->GetTranslation('admin_usr_typeowner') .'</option>');
            echo('        <option value="' . $USERTYPE_ADMINISTRATOR . '"');
            if ($usrType == $USERTYPE_ADMINISTRATOR)
                echo(' selected');
            echo_r ('>'. $cTrans->GetTranslation('admin_usr_typeadmin') .'</option>');
            echo_r('   </select></td>');
        }
        else
        {
            echo_r('    <td>');
            if ($usrType == $USERTYPE_CUSTOMER)
                echo_r($cTrans->GetTranslation('admin_usr_typecustomer'));
            else if ($usrType == $USERTYPE_REPORTER)
                echo_r($cTrans->GetTranslation('admin_usr_typereporter'));
            else if ($usrType == $USERTYPE_SITEOWNER)
                echo_r($cTrans->GetTranslation('admin_usr_typeowner'));
            else
                echo_r($cTrans->GetTranslation('admin_usr_typeadmin'));

            echo_r('      <input type="hidden" name="usr_type" value="' . $usrType . '">');
            echo_r('    </td>');
        }
        echo_r('  </tr>');
        echo_r('  <tr><td>' . $cTrans->GetTranslation('admin_usr_address') . ':</td><td><br></td></tr>');
        echo_r('  <tr>');
        echo_r('    <td>' . $cTrans->GetTranslation('admin_usr_firstname') . ':</td>');
        if (isset($_POST['usr_firstname']))
            echo_r('    <td><input type="text" name="usr_firstname" size="30" value="' . $_POST['usr_firstname'] . '"></td>');
        else
            echo_r('    <td><input type="text" name="usr_firstname" size="30" value="' . $usrUser->GetFirstName() . '"></td>');
        echo_r('  </tr>');
        echo_r('  <tr>');
        echo_r('    <td>' . $cTrans->GetTranslation('admin_usr_lastname') . ':</td>');
        if (isset($_POST['usr_lastname']))
            echo_r('    <td><input type="text" name="usr_lastname" size="30" value="' . $_POST['usr_lastname'] . '"></td>');
        else
            echo_r('    <td><input type="text" name="usr_lastname" size="30" value="' . $usrUser->GetLastName() . '"></td>');
        echo_r('  </tr>');
        echo_r('  <tr>');
        echo_r('    <td>' . $cTrans->GetTranslation('admin_usr_street') . ':</td>');
        if (isset($_POST['usr_street']))
            echo_r('    <td><input type="text" name="usr_street" size="30" value="' . $_POST['usr_street'] . '"></td>');
        else
            echo_r('    <td><input type="text" name="usr_street" size="30" value="' . $usrUser->GetStreet() . '"></td>');
        echo_r('  </tr>');
        echo_r('  <tr>');
        echo_r('    <td>' . $cTrans->GetTranslation('admin_usr_streetno') . ':</td>');
        if (isset($_POST['usr_streetno']))
            echo_r('    <td><input type="text" name="usr_streetno" size="5" value="' . $_POST['usr_streetno'] . '"></td>');
        else
            echo_r('    <td><input type="text" name="usr_streetno" size="5" value="' . $usrUser->GetStreetNo() . '"></td>');
        echo_r('  </tr>');
        echo_r('  <tr>');
        echo_r('    <td>' . $cTrans->GetTranslation('admin_usr_zipcode') . ':</td>');
        if (isset($_POST['usr_zipcode']))
            echo_r('    <td><input type="text" name="usr_zipcode" size="10" value="' . $_POST['usr_zipcode'] . '"></td>');
        else
            echo_r('    <td><input type="text" name="usr_zipcode" size="10" value="' . $usrUser->GetZipCode() . '"></td>');
        echo_r('  </tr>');
        echo_r('  <tr>');
        echo_r('    <td>' . $cTrans->GetTranslation('admin_usr_city') . ':</td>');
        if (isset($_POST['usr_city']))
            echo_r('    <td><input type="text" name="usr_city" size="30"  value="' . $_POST['usr_city'] . '"></td>');
        else
            echo_r('    <td><input type="text" name="usr_city" size="30"  value="' . $usrUser->GetCity() . '"></td>');
        echo_r('  </tr>');
        echo_r('  <tr>');
        echo_r('    <td>' . $cTrans->GetTranslation('admin_usr_land') . ':</td>');
        if (isset($_POST['usr_land']))
            echo_r('    <td><input type="text" name="usr_land" size="30"  value="' . $_POST['usr_land'] . '"></td>');
        else
            echo_r('    <td><input type="text" name="usr_land" size="30"  value="' . $usrUser->GetLand() . '"></td>');
        echo_r('  </tr>');
        echo_r('  <tr>');
        echo_r('    <td>' . $cTrans->GetTranslation('admin_usr_phoneno') . ':</td>');
        if (isset($_POST['usr_phoneno']))
            echo_r('    <td><input type="text" name="usr_phoneno" size="30"  value="' . $_POST['usr_phoneno'] . '"></td>');
        else
            echo_r('    <td><input type="text" name="usr_phoneno" size="30"  value="' . $usrUser->GetTelephoneNo() . '"></td>');
        echo_r('  </tr>');
        echo_r('  <tr>');
        echo_r('    <td>' . $cTrans->GetTranslation('admin_usr_email') . ':</td>');
        if (isset($_POST['usr_email']))
            echo_r('    <td><input type="text" name="usr_email" size="30"  value="' . $_POST['usr_email'] . '"></td>');
        else
            echo_r('    <td><input type="text" name="usr_email" size="30"  value="' . $usrUser->GetEmail() . '"></td>');
        echo_r('  </tr>');
        echo_r('  <tr>');
        echo_r('    <td></td>');
        $wantsNewsletter = 0;
        if (isset($_POST['usr_newsletter']) && $_POST['usr_newsletter'] == "1")
            $wantsNewsletter = 1;
        else if ($usrUser->WantsNewsletter() == true)
            $wantsNewsletter = 1;
        echo ('    <td><input type="checkbox" name="usr_newsletter" value="1"');
        if ($wantsNewsletter == 1)
            echo (' checked');
        echo_r ('>' . $cTrans->GetTranslation('admin_usr_wantsnewsletter') . '</td>');
        echo_r('  </tr>');
        echo_r('</table>');

        if ($usrEdtAction == "edit")  // Edit
            print_bottom_links("usr_Save", $cTrans->GetTranslation('admin_save'),
                               "usr_Cancel", $cTrans->GetTranslation('admin_cancel'), false);
        else  // New
            print_bottom_links("usr_Save", $cTrans->GetTranslation('admin_create'),
                               "usr_Cancel", $cTrans->GetTranslation('admin_cancel'), false);

    }
    echo_r('<input type="hidden" name="usr_EdtAction" value="' . $usrEdtAction . '">');
    echo_r('<input type="hidden" name="usr_mode" value="' . $usrMode . '">');
    echo_r('</form>');

    print_admin_footer();
?>