<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         modify_article.php
Description:  Administrative module to lock/unlock/delete an article

*/

    include "../modules/class_article.php";
    include "../modules/mod_config.php";
    include "../modules/mod_admin.php";
    include "../modules/class_translation.php";

    $artArticle = new cArticle;
    $artArticle->SetFolder($ARTICLE_FOLDER);
    $artArticle->SetCustFieldCount($ARTICLE_CUSTOM_FIELD_COUNT);
    $bArticleLoadFailed = false;
    $artModAction = "unlock";
    $artId = "";
    $errorString = "";

    // Check privileges
    check_login();
    if (user_is_customer() == true || (user_is_reporter() == true && $artModAction == "delete"))
    {
        log_out();
        return;
    }

    // Get action
    if (isset ($_POST['art_action']) == true)
    {
        if ($_POST['art_action'] == "lock")
            $artModAction = "lock";
        else if ($_POST['art_action'] == "delete")
            $artModAction = "delete";
    }
    else if (isset ($_GET['action']) == true)
    {
        if ($_GET['action'] == "lock")
            $artModAction = "lock";
        else if ($_GET['action'] == "delete")
            $artModAction = "delete";
    }


    if (isset ($_POST['art_id']) == true)
        $artId = $_POST['art_id'];
    else if (isset ($_GET['id']) == true)
        $artId = $_GET['id'];

    if ($artArticle->LoadArticleFromId($artId) == false)
    {
        $errorString = $cTrans->GetTranslation('admin_artmod_errorload') . ' ' . $artId . '!!';
        $bArticleLoadFailed = true;
    }

    // Cancel modification?
    if (isset ($_POST['art_Cancel']))
    {
        header ('Location: ' . $ADMIN_ARTLIST_SITE);
        return;
    }
    // Modify article?
    if (isset ($_POST['art_DoAction']) && $bArticleLoadFailed == false)
    {
        if ($artModAction == "lock")
        {
            if ($artArticle->SetLocked(true) == false)
                $errorString = $cTrans->GetTranslation('admin_artmod_errorlock') . ' ' . $artId . '!!';
            else
            {
                log_message ('User ' . get_user_name() . ' locked article ' . $artArticle->GetId());
                header ('Location: ' . $ADMIN_ARTLIST_SITE);
                return;
            }
        }
        else if ($artModAction == "delete")
        {
            if ($artArticle->DeleteArticelFinal() == false)
                $errorString = $cTrans->GetTranslation('admin_artmod_errordelete') . ' ' . $artId . '!!';
            else
            {
                log_message ('User ' . get_user_name() . ' deleted article ' . $artArticle->GetId());
                header ('Location: ' . $ADMIN_ARTLIST_SITE);
                return;
            }
        }
        else
        {
            if ($artArticle->SetLocked(false) == false)
                $errorString = $cTrans->GetTranslation('admin_artmod_errorunlock') . ' ' . $artId . '!!';
            else
            {
                log_message ('User ' . get_user_name() . ' unlocked article ' . $artArticle->GetId());
                header ('Location: ' . $ADMIN_ARTLIST_SITE);
                return;
            }
        }
    }

    // Display
    $titleString = $cTrans->GetTranslation('admin_artmod_unlockhead');
    if ($artModAction == "lock")
        $titleString = $cTrans->GetTranslation('admin_artmod_lockhead');
    else if ($artModAction == "delete")
        $titleString = $cTrans->GetTranslation('admin_artmod_deletehead');
    print_admin_header($titleString, true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'),
                       $ADMIN_ARTLIST_SITE, $cTrans->GetTranslation('admin_artl_button'));
    if ($errorString != "")
        print_error_message($errorString);

    if ($artModAction == "lock")
        echo_r('<p>' . $cTrans->GetTranslation('admin_artmod_questlock') . ':</p><br>');
    else if ($artModAction == "delete")
        echo_r('<p>' . $cTrans->GetTranslation('admin_artmod_questdelete') . ':</p><br>');
    else
        echo_r('<p>' . $cTrans->GetTranslation('admin_artmod_questunlock') . ':</p><br>');
    echo_r('<table width="100%" border="0">');
    echo_r('  <tr>');
    echo_r('    <td width="40%">');
    echo_r('       <img src="' . $artArticle->GetImgThumbUrl() . '" width="' . $THUMB_IMAGE_WIDTH .'" height="' . $THUMB_IMAGE_HEIGHT . '" alt="">');
    echo_r('    </td>');
    echo_r('    <td width="60%">');
    echo_r('       ' . $cTrans->GetTranslation('admin_art_id') . ': ' . $artArticle->GetId() . '<br>');
    echo_r('       ' . $cTrans->GetTranslation('admin_art_date') . ': ' . $artArticle->GetDate() . '<br>');
    echo_r('       ' . $cTrans->GetTranslation('admin_art_name') . ': ' . $artArticle->GetName() . '<br>');
    echo_r('       ' . $cTrans->GetTranslation('admin_art_price') . ': ' . $artArticle->GetPrice() . ' ' . $SHOP_CURRENCY .'<br>');
    echo_r('    </td>');
    echo_r('  </tr>');
    echo_r('</table>');
    
    echo_r('<form method="post" action="">');
    print_bottom_links("art_DoAction", $cTrans->GetTranslation('admin_yes'),
                       "art_Cancel", $cTrans->GetTranslation('admin_cancel'), false);
    echo_r('  <input type="hidden" value="' .  $artId . '" name="art_id">  ');
    echo_r('  <input type="hidden" value="' .  $artModAction . '" name="art_action">  ');
    echo_r('</form>');

    print_admin_footer();
?>